var $ = jQuery;
$(function() {
    var INPUT_BORDER_COLOR = "#d7d7d7";
    var jSubjectSelect = $("select.SelectSubject");
    var jSubjectInput = $("input.InputSubject ");
    var jGradeSelect = $("select.SelectGrade");
    var jType = $("input[name=type]");

    // Изменения базовых параметров дисциплины
    $(".AddDiscipline").click(function() {
        var self = $(this);
        self.attr("disabled", true);

        var errCount = 0;
        var subjectID = parseInt(jSubjectSelect.val());

        var type = jType.filter(":radio:checked").val();
        if (type === undefined) {
            jType.first().parent().parent().css("background-color", "#f2b4b4");
            ++errCount;
        }

        if (type != 'scientific' && (!isNum(subjectID) || subjectID <= 0)) {
            jSubjectInput.css("border-color", "red");
            ++errCount;
        }

        var gradeID = parseInt(jGradeSelect.val());
        if (!isNum(gradeID) || gradeID <= 0) {
            jGradeSelect.css("border-color", "red");
            ++errCount;
        }

        if (errCount === 0) {
            $.post(
                g_URLdir + "handler/coursework/add",
                {
                    "subjectID": subjectID,
                    "grade": gradeID,
                    "type": type,
                    "facultyID": $("select.SelectFaculty").val()
                },
                function(data) {
                    data = $.parseJSON(data);
                    if (data.success === true) {
                        setTimeout("location.replace('" + g_URLdir + "discipline/structure/" + data.id + "')", 500);
                    } else {
                        self.removeAttr("disabled");
                        EventInspector_ShowMsg("Ошибка при добавлении дисциплины", "error");
                    }
                }
            );
        } // errCount === 0 
        else {
            self.removeAttr("disabled");
            EventInspector_ShowMsg("Заполнены не все поля", "error");
        }
    });

    jSubjectSelect.change(function() {
        if ($(this).val() > 0)
            jSubjectSelect.css("border-color", INPUT_BORDER_COLOR);
    });

    jGradeSelect.change(function() {
        if ($(this).val() > 0)
            jGradeSelect.css("border-color", INPUT_BORDER_COLOR);
    });

    jType.change(function() {
        var value = jType.filter(":radio:checked").val();
        if (value in ["scientific", "disciplinary"])
            $(this).parent().parent().css("background-color", "#fff");

        if (value === "scientific") {
            jSubjectSelect.attr("disabled", "disabled");
            $("#subjects").fadeOut(500);
        } else {
            jSubjectSelect.removeAttr("disabled");
            $("#subjects").fadeIn(500);
        }
    });
});